pipeline {
    agent any
    tools {
        maven 'maven-3.9'
    }

    environment {
        DOCKERHUB_CREDENTIALS = credentials('docker-hub-credential')
    }

    stages {
        stage('Initialize') {
            steps {
                sh '''
                    echo "PATH = ${PATH}"
                    echo "M2_HOME = ${M2_HOME}"
                '''

                script {
                    echo "branch name ${BRANCH_NAME}"
                }
            }
        }

        stage('Build') {

            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }

            steps {
                echo 'This is a minimal pipeline.'
                sh 'mvn package'
            }
        }

        stage('Build Docker Image') {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                sh 'docker build . -t mugna87/demo-app-from-jenkins:from-jenkins-pipeline-1.0'
                echo 'Build Image Completed'
            }
        }
        stage('Login to Docker Hub') {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                sh 'echo $DOCKERHUB_CREDENTIALS_PSW | docker login -u $DOCKERHUB_CREDENTIALS_USR --password-stdin'
                echo 'Login Completed'
            }
        }
        stage('Push Image to Docker Hub') {
            when {
                expression {
                    BRANCH_NAME == 'master'
                }
            }
            steps {
                sh 'docker push mugna87/demo-app-from-jenkins:from-jenkins-pipeline-1.0'
                echo 'Push Image Completed'
            }
        }
    } //stages

    post {
        always {
            sh 'docker logout'
        }
    }
}
